/*
	A basic extension of the java.awt.Dialog class
 */

import java.awt.*;
import symantec.itools.awt.WrappingLabel;

public class DialogError extends Dialog
{
	public DialogError(Frame parent)
	{
		super(parent);

		// This code is automatically generated by Visual Cafe when you add
		// components to the visual environment. It instantiates and initializes
		// the components. To modify the code, only use code syntax that matches
		// what Visual Cafe can generate, or Visual Cafe may be unable to back
		// parse your Java file into its visual environment.
		//{{INIT_CONTROLS
		setLayout(null);
		setSize(645,361);
		setVisible(false);
		buttonAceptar.setLabel("Aceptar");
		add(buttonAceptar);
		buttonAceptar.setBackground(java.awt.Color.lightGray);
		buttonAceptar.setBounds(252,294,124,39);
		add(labelMsg);
		labelMsg.setBounds(36,66,588,210);
		//}}

		//{{REGISTER_LISTENERS
		SymWindow aSymWindow = new SymWindow();
		this.addWindowListener(aSymWindow);
		SymMouse aSymMouse = new SymMouse();
		buttonAceptar.addMouseListener(aSymMouse);
		//}}
	}
	
	public DialogError(Frame parent, boolean modal)
	{
		this(parent);
        setModal(modal);
	}
	
	public void addNotify()
	{
  	    // Record the size of the window prior to calling parents addNotify.
	    Dimension d = getSize();

		super.addNotify();

		if (fComponentsAdjusted)
			return;

		// Adjust components according to the insets
		Insets insets = getInsets();
		setSize(insets.left + insets.right + d.width, insets.top + insets.bottom + d.height);
		Component components[] = getComponents();
		for (int i = 0; i < components.length; i++)
		{
			Point p = components[i].getLocation();
			p.translate(insets.left, insets.top);
			components[i].setLocation(p);
		}
		fComponentsAdjusted = true;
	}

    // Used for addNotify check.
	boolean fComponentsAdjusted = false;

	public DialogError(Frame parent, String msg)
	{
		this(parent, true);
		setTitle("Error");
		try { labelMsg.setText(msg); }
		catch (Exception e) {}
	}

	public DialogError(Frame parent, String title, boolean modal, String msg)
	{
		this(parent, modal);
		setTitle(title);
		try { labelMsg.setText(msg); }
		catch (Exception e) {}
	}

    /**
     * Shows or hides the component depending on the boolean flag b.
     * @param b  if true, show the component; otherwise, hide the component.
     * @see java.awt.Component#isVisible
     */
    public void setVisible(boolean b)
	{
		if(b)
		{
			Rectangle bounds = getParent().getBounds();
			Rectangle abounds = getBounds();
	
			setLocation(bounds.x + (bounds.width - abounds.width)/ 2,
				 bounds.y + (bounds.height - abounds.height)/2);
		}
		super.setVisible(b);
	}

	//{{DECLARE_CONTROLS
	java.awt.Button buttonAceptar = new java.awt.Button();
	symantec.itools.awt.WrappingLabel labelMsg = new symantec.itools.awt.WrappingLabel();
	//}}

	class SymWindow extends java.awt.event.WindowAdapter
	{
		public void windowClosing(java.awt.event.WindowEvent event)
		{
			Object object = event.getSource();
			if (object == DialogError.this)
				DialogError_WindowClosing(event);
		}
	}
	
	void DialogError_WindowClosing(java.awt.event.WindowEvent event)
	{
		setVisible(false);
	}

	class SymMouse extends java.awt.event.MouseAdapter
	{
		public void mouseClicked(java.awt.event.MouseEvent event)
		{
			Object object = event.getSource();
			if (object == buttonAceptar)
				buttonAceptar_MouseClicked(event);
		}
	}

	void buttonAceptar_MouseClicked(java.awt.event.MouseEvent event)
	{
		dispose();
	}
}
