/*
	A basic extension of the java.awt.Frame class
 */

import java.awt.*;
import java.lang.reflect.Field;
import java.util.Vector;

public class FrameCPIGeneral extends FrameCPI2
{
    public CPI mPropio;
    private Field mCampos[];
    private Vector mtexts, mlabels;
    
	public FrameCPIGeneral(String title)
	{
	    super();
		// This code is automatically generated by Visual Cafe when you add
		// components to the visual environment. It instantiates and initializes
		// the components. To modify the code, only use code syntax that matches
		// what Visual Cafe can generate, or Visual Cafe may be unable to back
		// parse your Java file into its visual environment.
		//{{INIT_CONTROLS
		setLayout(null);
		setSize(473,230);
		setVisible(false);
		setTitle(title);
		//}}

		//{{INIT_MENUS
		//}}

		//{{REGISTER_LISTENERS
		SymWindow aSymWindow = new SymWindow();
		this.addWindowListener(aSymWindow);
		//}}
		ColocaBotones();
	}
	
	public FrameCPIGeneral(FrameListaGenerica f, String title, CPI o)
	{
		this(title);
		int altura=0;
		if (f!=null) {
		    mFila=f.JTable1.getSelectedRow();
		    this.mLista=f;
		} 
		Class clase=o.getClass();
		mCampos=clase.getDeclaredFields();		

        System.out.println("La clase es " + clase.getName() + " y tiene " + 
            clase.getDeclaredFields().length + " campos");

        mtexts=new Vector();
        mlabels=new Vector();
        int i=0;
        for (i=0; i<mCampos.length; i++) {
            Label l=new Label(trim(mCampos[i].getName())+":");
		    l.setAlignment(java.awt.Label.RIGHT);
		    l.setBounds(20,20+30*(i+1),110,25);
		    mlabels.addElement(l);
		    add(l);
		    TextField t=new TextField();
		    t.setBounds(135,20+30*(i+1),154,25);
		    mtexts.addElement(t);
		    add(t);
        }
		altura=45+30*(i+1);
        this.setSize(this.getSize().width, altura);
		mPropio=o;
		mObjeto=mPropio;
		mOperacion=CTES.CONSULTA;
		Carga();
		Habilita();
	}

    String trim(String fieldName) {
        if (fieldName.substring(0, 3).compareTo("mPK")==0)
            fieldName=fieldName.substring(3, fieldName.length());        
        else
            fieldName=fieldName.substring(1, fieldName.length());        
        return fieldName;
    }
    
    protected void Carga() {
        try {
            for (int i=0; i<mlabels.size(); i++) {
                TextField t=(TextField) mtexts.elementAt(i);
                Field campo=mCampos[i];
                t.setText(campo.get(mPropio).toString());
            }
        }
        catch (Exception e) {
            //CTES.Error("FrameCPIGeneral::Carga(): " + e.toString());
        }
    }
    
    protected void Recargar() throws Exception {
        for (int i=0; i<mCampos.length; i++) {
            Field campo=mCampos[i];
            TextField t=(TextField) mtexts.elementAt(i);
            if (campo.getType().toString().compareTo("class java.lang.Long")==0)
                campo.set(mPropio, new Long(t.getText())); else
            if (campo.getType().toString().compareTo("class java.lang.Integer")==0)
                campo.set(mPropio, new Integer(t.getText())); else
            if (campo.getType().toString().compareTo("class java.lang.Double")==0)
                campo.set(mPropio, new Double(t.getText())); else
            if (campo.getType().toString().compareTo("class java.lang.String")==0)
                campo.set(mPropio, new String(t.getText())); 
        }
    }

    /**
     * Shows or hides the component depending on the boolean flag b.
     * @param b  if true, show the component; otherwise, hide the component.
     * @see java.awt.Component#isVisible
     */
    public void setVisible(boolean b)
	{
		if(b)
		{
			setLocation(50, 50);
		}
		super.setVisible(b);
	}

	public void addNotify()
	{
	    // Record the size of the window prior to calling parents addNotify.
	    Dimension d = getSize();
	    
		super.addNotify();

		if (fComponentsAdjusted)
			return;

		// Adjust components according to the insets
		Insets insets = getInsets();
		setSize(insets.left + insets.right + d.width, insets.top + insets.bottom + d.height);
		Component components[] = getComponents();
		for (int i = 0; i < components.length; i++)
		{
			Point p = components[i].getLocation();
			p.translate(insets.left, insets.top);
			components[i].setLocation(p);
		}
		fComponentsAdjusted = true;
	}

    // Used for addNotify check.
	boolean fComponentsAdjusted = false;

	//{{DECLARE_CONTROLS
	//}}

	//{{DECLARE_MENUS
	//}}

	class SymWindow extends java.awt.event.WindowAdapter
	{
		public void windowClosing(java.awt.event.WindowEvent event)
		{
			Object object = event.getSource();
			if (object == FrameCPIGeneral.this)
				FrameCPIGeneral_WindowClosing(event);
		}
	}
	
	void FrameCPIGeneral_WindowClosing(java.awt.event.WindowEvent event)
	{
		setVisible(false);		 // hide the Frame
	}
}
