/*
	A basic extension of the java.awt.Frame class
 */

import java.awt.*;
import com.symantec.itools.swing.JChart;
import java.sql.ResultSet;
import com.symantec.itools.swing.models.StringTableModel;
import java.util.Vector;

public class FrameInforme extends Frame
{
    Plantilla mPropio;
	public FrameInforme()
	{
		// This code is automatically generated by Visual Cafe when you add
		// components to the visual environment. It instantiates and initializes
		// the components. To modify the code, only use code syntax that matches
		// what Visual Cafe can generate, or Visual Cafe may be unable to back
		// parse your Java file into its visual environment.
		//{{INIT_CONTROLS
		setLayout(null);
		setSize(776,300);
		setVisible(false);
		JChart1.setModel(stringTableModel1);
		add(JChart1);
		JChart1.setBounds(12,60,372,204);
		label1.setText("Notas");
		label1.setAlignment(java.awt.Label.CENTER);
		add(label1);
		label1.setFont(new Font("Dialog", Font.BOLD, 12));
		label1.setBounds(96,36,201,22);
		//$$ stringTableModel1.move(0,301);
		stringTableModel2.setColumnHeaders("Suspensos, Aprobados, Notables, Sobresalientes");
		//$$ stringTableModel2.move(0,0);
		JChart2.setModel(stringTableModel2);
		JChart2.setStyle(com.symantec.itools.swing.JChart.PIE_STYLE);
		add(JChart2);
		JChart2.setBounds(396,60,372,204);
		label2.setText("Procentajes");
		label2.setAlignment(java.awt.Label.CENTER);
		add(label2);
		label2.setFont(new Font("Dialog", Font.BOLD, 12));
		label2.setBounds(480,36,201,22);
		setTitle("A Simple Frame");
		//}}

		//{{INIT_MENUS
		//}}

		//{{REGISTER_LISTENERS
		SymWindow aSymWindow = new SymWindow();
		this.addWindowListener(aSymWindow);
		//}}
	}

	public FrameInforme(Plantilla p)
	{
		this();
		setTitle("Informe de los exmenes de la plantilla " + p.mPKPlantilla);
		mPropio=p;
		String SQL="Select Nota from Examen where Plantilla='" + 
		    mPropio.mPKPlantilla + "'";
		try {
		    ResultSet r=Inicio.bd.createStatement().executeQuery(SQL);
		    double dmax=mPropio.getNotaMaxima();
		    String max=new Double(dmax).toString();
		    Vector valores=new Vector();
		    int total=0;
		    double nota=0;
		    int s, a, n, sb; s=a=n=sb=0;
		    while (r.next()) {
		        double notaIndi=r.getDouble(1);
		        if (notaIndi/dmax<0.5) s++; else
		        if (notaIndi/dmax<0.7) a++; else
		        if (notaIndi/dmax<0.9) n++; else sb++;
		        nota=nota+notaIndi;
		        valores.addElement(new Double(notaIndi).toString());
		        total++;
		    }
		    nota=nota/total;
		    String sNota=new Double(nota).toString();
			String[] tempString = new String[valores.size()];
			for (int i=0; i<valores.size(); i++) {
			    tempString[i]=valores.elementAt(i).toString()+","+max+","+sNota;
			}
			stringTableModel1.setItems(tempString);
			String tempString2[]=new String[4];
			tempString2[0]=new Double(s).toString();
			tempString2[1]=new Double(a).toString();
			tempString2[2]=new Double(n).toString();
			tempString2[3]=new Double(sb).toString();
			stringTableModel2.setItems(tempString2);
		}
		catch (Exception e) {
		    Dialog d=new DialogError(this, e.toString());
		    d.setVisible(true); d.dispose();
		}
	}

    /**
     * Shows or hides the component depending on the boolean flag b.
     * @param b  if true, show the component; otherwise, hide the component.
     * @see java.awt.Component#isVisible
     */
    public void setVisible(boolean b)
	{
		if(b)
		{
			setLocation(50, 50);
		}
		super.setVisible(b);
	}

	static public void main(String args[])
	{
		(new FrameInforme()).setVisible(true);
	}
	
	public void addNotify()
	{
	    // Record the size of the window prior to calling parents addNotify.
	    Dimension d = getSize();
	    
		super.addNotify();

		if (fComponentsAdjusted)
			return;

		// Adjust components according to the insets
		Insets insets = getInsets();
		setSize(insets.left + insets.right + d.width, insets.top + insets.bottom + d.height);
		Component components[] = getComponents();
		for (int i = 0; i < components.length; i++)
		{
			Point p = components[i].getLocation();
			p.translate(insets.left, insets.top);
			components[i].setLocation(p);
		}
		fComponentsAdjusted = true;
	}

    // Used for addNotify check.
	boolean fComponentsAdjusted = false;

	//{{DECLARE_CONTROLS
	com.symantec.itools.swing.JChart JChart1 = new com.symantec.itools.swing.JChart();
	java.awt.Label label1 = new java.awt.Label();
	com.symantec.itools.swing.models.StringTableModel stringTableModel1 = new com.symantec.itools.swing.models.StringTableModel();
	com.symantec.itools.swing.models.StringTableModel stringTableModel2 = new com.symantec.itools.swing.models.StringTableModel();
	com.symantec.itools.swing.JChart JChart2 = new com.symantec.itools.swing.JChart();
	java.awt.Label label2 = new java.awt.Label();
	//}}

	//{{DECLARE_MENUS
	//}}

	class SymWindow extends java.awt.event.WindowAdapter
	{
		public void windowClosing(java.awt.event.WindowEvent event)
		{
			Object object = event.getSource();
			if (object == FrameInforme.this)
				FrameInforme_WindowClosing(event);
		}
	}
	
	void FrameInforme_WindowClosing(java.awt.event.WindowEvent event)
	{
		setVisible(false);		 // hide the Frame
	}
}
