import java.sql.ResultSet;
import java.util.Vector;
import java.util.Enumeration;
import java.math.*;
import java.io.*;

public class Plantilla extends CPI {
    String mPKPlantilla;
    String mTema;
    Double mAcierto, mError, mBlanco;
    
    Plantilla() {
        super();
    }
    
    Plantilla (String plantilla[]) {
        super(plantilla);
    }
    
    public double getNotaMaxima() {
        String SQL="Select count(Respuesta) from RespuestaDePlantilla where " +
            "Plantilla='" + mPKPlantilla + "' and Correcta";
        try {
            ResultSet r=Inicio.bd.createStatement().executeQuery(SQL);
            if (r.next()) 
                return r.getDouble(1);
            else return 0;
        }
        catch (Exception e) {
            return 0;
        }
    }
    
    public void generarExamenes(int n) throws Exception {
        Vector pregs, respsAgrup;
        pregs=new Vector();
        respsAgrup=new Vector();
        String SQL="Select * from PreguntaDePlantilla where " +
            "Plantilla='" + mPKPlantilla + "'";
        ResultSet rP=Inicio.bd.createStatement().executeQuery(SQL);
        while (rP.next()) {
            Vector resps=new Vector();
            PreguntaDePlantilla p=new PreguntaDePlantilla();
            p.mPKPlantilla=rP.getString(1);
            p.mPKPregunta=rP.getString(2);
            pregs.addElement(p);        
            SQL="Select * from " +
                "RespuestaDePlantilla where Plantilla='" + mPKPlantilla + "' " +
                "and Pregunta='" + p.mPKPregunta + "'";
            ResultSet rR=Inicio.bd.createStatement().executeQuery(SQL);
            while (rR.next()) {
                RespuestaDePlantilla r=new RespuestaDePlantilla();
                r.mPKPlantilla=rR.getString(1);
                r.mPKPregunta=rR.getString(2);
                r.mPKRespuesta=rR.getString(3);
                r.mCorrecta=new Boolean(rR.getBoolean(4));
                resps.addElement(r);
            }
            respsAgrup.addElement(resps);
        }
        
        OutputStream f=new FileOutputStream("docs/examen.html");
        for (long i=0; i<n; i++) {
            Vector copiaPregs=(Vector) pregs.clone();
            Vector copiaResps=copiaRespuestas(respsAgrup);
            Vector pr=generarExamen(copiaPregs, copiaResps);
            imprimirExamen(i, f, pr);
            Examen e=construirExamen(i, pr);
            e.Insert();
        }
        f.close();
    }
    
    private Examen construirExamen(long n, Vector pr) {
        Examen resul=new Examen();
        Vector resps=(Vector) pr.elementAt(1);
        for (int i=0; i<resps.size(); i++) {
            Vector resp=(Vector) resps.elementAt(i);
            for (int j=0; j<resp.size(); j++) {
                RespuestaDePlantilla r=(RespuestaDePlantilla) resp.elementAt(j);
                if (r.mCorrecta.booleanValue()) {
                    resul.mSecuenciaCorrecta=resul.mSecuenciaCorrecta+(j+1);
                    resul.mPKPlantilla=r.mPKPlantilla;
                    resul.mPKExamen=new Long(n+1);
                    break;
                }
            }
        }
        return resul;
    }
    
    private Vector copiaRespuestas(Vector respsAgrup) {
        Vector resul=new Vector();
        for (int i=0; i<respsAgrup.size(); i++) {
            Vector orig=(Vector) respsAgrup.elementAt(i);
            Vector copia=(Vector) orig.clone();
            resul.addElement(copia);
        }        
        return resul;
    }
        
    private Vector generarExamen(Vector pregs, Vector respsAgrup) {
        Vector pr=desordenarTodo(pregs, respsAgrup);
        respsAgrup=(Vector) pr.elementAt(1);
        for (int i=0; i<respsAgrup.size(); i++) {
            Vector v=(Vector) respsAgrup.elementAt(i);
            v=desordenar(v);
            respsAgrup.setElementAt(v, i);
        }
        return pr;
    }
    
    private Vector desordenarTodo(Vector pregs, Vector respsAgrup) {
        int num=pregs.size();
        Vector resulPreg=new Vector();
        Vector resulResp=new Vector();
        for (int i=0; i<num; i++) {
            double aleat=Math.random();
            double amplitud=1/(double) pregs.size();
            int pos=(int) (aleat/amplitud);
            resulPreg.addElement(pregs.elementAt(pos));
            resulResp.addElement(respsAgrup.elementAt(pos));
            pregs.removeElementAt(pos);
            respsAgrup.removeElementAt(pos);
        }
        Vector resul=new Vector();
        resul.addElement(resulPreg);
        resul.addElement(resulResp);
        return resul;
    }    
    
    private Vector desordenar(Vector v) {
        int num=v.size();
        Vector resul=new Vector();
        for (int i=0; i<num; i++) {
            double aleat=Math.random();
            double amplitud=1/(double) v.size();
            int pos=(int) (aleat/amplitud);
            resul.addElement(v.elementAt(pos));
            v.removeElementAt(pos);
        }
        return resul;
    }
    
    private void imprimirExamen(long n, OutputStream f, Vector pr) throws Exception {
        Vector pregs=(Vector) pr.elementAt(0);
        Vector resps=(Vector) pr.elementAt(1);
        String ini="<h1>Examen n " + (n+1) + "</h1>" +
            "<b>Nombre: ______________________ Apellidos: __________________________" +
            "<p>DNI: __________________</b><p>" +
            "<u>Nota:</u> Indique la respuesta correcta de cada pregunta en la siguiente tabla\n";
        
        ini=ini+"<table border='1'><tr>";
        for (int i=0; i<resps.size(); i++) 
            ini=ini+"<td>Preg. " + (i+1) + "</td>";
        ini=ini+"</tr>";
        for (int i=0; i<resps.size(); i++) 
            ini=ini+"<td width='" + (100/resps.size()) +"%'>&nbsp;</td>";        
        ini=ini+"</tr></table>";
        for (int k=0; k<ini.length(); k++) 
            f.write((int) ini.charAt(k));
       
        for (int j=0; j<pregs.size(); j++) {
            PreguntaDePlantilla p=(PreguntaDePlantilla) pregs.elementAt(j);
            String texto="<b>Pregunta "+ (j+1) + ". </b>" + p.mPKPregunta+"<p>";
            for (int k=0; k<texto.length(); k++)
                f.write((int) texto.charAt(k));
            f.write(10); f.write(13);
            Vector respAPreg=(Vector) resps.elementAt(j);
            imprimeRespuestas(f, respAPreg);
        }
        String fin="----- Fin de examen -----\n\n";
        for (int k=0; k<fin.length(); k++) 
            f.write((int) fin.charAt(k));
    }
    
    private void imprimeRespuestas(OutputStream f, Vector resps) throws Exception {
        for (int j=0; j<resps.size(); j++) {
            RespuestaDePlantilla r=(RespuestaDePlantilla) resps.elementAt(j);
            String texto="<blockquote>" + (j+1) + ".- " + r.mPKRespuesta + "</blockquote>";
            for (int k=0; k<texto.length(); k++) 
                f.write((int) texto.charAt(k));
        }
    }        
}