import java.util.Date;
import java.lang.reflect.Field;
import java.io.*;
import java.awt.List;
import java.awt.Frame;

class RTFProcessor {
    private FrameCPI2 mPantalla;
    
    RTFProcessor(FrameCPI2 frame) {
        mPantalla=frame;
    }
    
    public void Imprimir() throws Exception {
        Date d=new Date();
        String plantilla=this.seleccionaPlantilla();
        String salida="docs/"+mPantalla.mObjeto.getClass().getName() + 
            d.getSeconds()+d.getMinutes()+d.getHours() + ".rtf";
        
        procesa("plantillas/"+plantilla, salida);
        abreEditorRTF(salida);
    }
    
	class FiltroRTF implements FilenameFilter {
	    String ext;
	    FiltroRTF() {
	        ext=".RTF"; 
	    }
	    public boolean accept (File dir, String name) {
	        return (name.toUpperCase().endsWith(ext));
	    }
	}
	
	private String seleccionaPlantilla() throws Exception {
	    List l=new List();
	    String resul=new String();
	    
	    String dirname="plantillas/";
	    FilenameFilter filtro=new FiltroRTF();
	    File f1=new File("plantillas/.");
	    String s[]=f1.list(filtro);
	    for (int i=0; i<s.length; i++) {
	        File f=new File(dirname + "/" + s[i]);
	        if (f.isFile())
	            l.add(s[i]);
	    }
	    DialogListilla d=new DialogListilla(mPantalla, l);
	    d.setVisible(true);
	    if (!d.mCancelado)
	        resul=d.mElemento;
	    return resul;
	}    
    
    private void procesa(String plantilla, String salida) throws Exception {
        Field campos[]=mPantalla.mObjeto.getClass().getDeclaredFields();
        InputStream fp=new FileInputStream(plantilla);
        OutputStream fs=new FileOutputStream(salida);
        
        int size=fp.available();
        for (int i=0; i<size; i++)  {
            char car=(char) fp.read(); 
            if (car!='#')
                fs.write(car);
            else {
                char car2=(char) fp.read();
                if (car2=='#') 
                    sustituye(fp, fs);
                else {
                    fs.write(car);
                    fs.write(car2);
                }
            } 
        }
        fp.close(); fs.close();
    }
    
    private void sustituye(InputStream fp, OutputStream fs) throws Exception {
        char c;
        String token=new String();
        while ((c=(char) fp.read())!='#') 
            token=token+new Character(c).toString();
        escribe(fs, token);
    }
    
    private void escribe(OutputStream fs, String token) throws Exception {
        try {
            Field campo=mPantalla.mObjeto.getClass().getDeclaredField("m"+token);
            String valor=campo.get(mPantalla.mObjeto).toString();
            if (valor!=null)
                for (int i=0; i<valor.length(); i++)
                    fs.write(valor.charAt(i));
        }
        catch (Exception e) {
            try {
                Field campo=mPantalla.mObjeto.getClass().getDeclaredField("mPK"+token);
                String valor=campo.get(mPantalla.mObjeto).toString();
                if (valor!=null)
                    for (int i=0; i<valor.length(); i++)
                        fs.write(valor.charAt(i));                
            }
            catch (Exception e2) {}
        }
    }
    
    private String trim(String fieldName) throws Exception {
        if (fieldName.substring(0, 3).compareTo("mPK")==0)
            fieldName=fieldName.substring(3, fieldName.length());        
        else
            fieldName=fieldName.substring(1, fieldName.length());        
        return fieldName;
    }    
    
    private void abreEditorRTF(String salida) throws Exception {
        char c;
        InputStream fcfg=new FileInputStream("cfg.ini");
        File f=new File(salida);
        salida=f.getAbsolutePath();
        int size=fcfg.available();
        String linea=new String();
        do {
            c=(char) fcfg.read();
            linea+=c;
        } while (!linea.endsWith("RTF"));
        linea=new String();
        do {
            c=(char) fcfg.read();
            if (c!=Character.LINE_SEPARATOR)
                linea+=c;
        } while (c!=Character.LINE_SEPARATOR);
		Runtime r=Runtime.getRuntime();
		String cmd[]={"\"" + linea.trim() + "\"", "\"" + salida.trim() + "\""};
		Process p=r.exec(cmd);
    }
}